/*
*********************************************************************************************************
*                                              uC/OS-II
*                                        The Real-Time Kernel
*
*                    Copyright 1992-2021 Silicon Laboratories Inc. www.silabs.com
*
*                                 SPDX-License-Identifier: APACHE-2.0
*
*               This software is subject to an open source license and is distributed by
*                Silicon Laboratories Inc. pursuant to the terms of the Apache License,
*                    Version 2.0 available at www.apache.org/licenses/LICENSE-2.0.
*
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*
*                                    MCS51-STC32 Specific code
*
* Filename : os_cpu_a.c
* Version  : V2.93.01
*ֲοSTC̳tzz1983ֲʹöʱ4ģжPendSv
*޸İ汾 V1.00
*޸ʱ䣺 2023-09-17
*ߣ
*QQ   616421684
*********************************************************************************************************
*/

#include  "config.h"
#include  <ucos_ii.h>
/*-----------------------------------------------------------*
δʱӳʼ
*-----------------------------------------------------------*/
#define TM0PS_VALUE    ( MAIN_Fosc / OS_TICKS_PER_SEC / 65536UL )
#define RELOAD_VALUE   ( 65536UL - MAIN_Fosc / (TM0PS_VALUE+1U) / OS_TICKS_PER_SEC )
static void SetupTimerInterrupt( void )
{
    AUXR |= 0x80;                           //1Tģʽ
    TMOD &= 0XF0;                           //ģʽ0
    TM0PS = TM0PS_VALUE;                    //Ƶϵ
    TL0 = ( uint8_t )( RELOAD_VALUE );      //װֵ
    TH0 = ( uint8_t )( RELOAD_VALUE >> 8 ); //װֵ
    TF0 = 0;                                //־
    ET0 = 1;                                //ʹж
    TR0 = 1;                                //ʱ
}

/*-----------------------------------------------------------*
PendSv жϳʼ
*-----------------------------------------------------------*/
static void prvPortPendSvInit(void)
{
    PendSv_PriorityConfigToLow();   //жϵȼ
    PendSv_ClearFlag();             //жϱ־
    PendSv_Enable();                //ʹж
}

/*-----------------------------------------------------------*
һлȥ
*-----------------------------------------------------------*/
void OSStartHighRdy(void)
{
    SetupTimerInterrupt();  //ʼTIME0
    prvPortPendSvInit();    //PendSvжϳʼ
    OSTaskSwHook();
    OSRunning = 1;

//1ʹERETأǰҪµջݣһУR4R5R6 κֵûϵ

//    //ȡSP
//    __asm   { MOV   DR4,OSTCBCur    }   
//    __asm   { MOV   WR2,@WR6+0x2    }   
//    __asm   { MOV   DR60,DR0        } 
//    
//    //Ĵջ
//    __asm   { POP   PSW     }               
//    __asm   { POP   DR0     }               
//    __asm   { POP   DR4     }               
//    __asm   { POP   DR8     }               
//    __asm   { POP   DR12    }               
//    __asm   { POP   DR16    }               
//    __asm   { POP   DR20    }               
//    __asm   { POP   DR24    }               
//    __asm   { POP   DR28    }               
//    __asm   { POP   DR56    }               

//    //PCPSW1ջ
//    __asm   { POP   R4      }               
//    __asm   { POP   R6      }               
//    __asm   { POP   R5      }               
//    __asm   { POP   PSW1    }
//    
//    //ѷصַʽERETķظ
//    __asm   { PUSH  R5    }               
//    __asm   { PUSH  R4    }               
//    __asm   { PUSH  R6    }
//    __asm   { SETB  EA      }
//    //ERETָתƵȥ, 0XAAERETָı
//    __asm   { DB    0AAH    }     

//2ʹRETIأϵͳտʼж϶ûпʼRETIȫûġ   
    
// 	//ȡSP
//    __asm   { MOV   DR4,OSTCBCur    }   
//    __asm   { MOV   WR2,@WR6+0x2    }   
//    __asm   { MOV   DR60,DR0        } 
//    
//    //Ĵջ
//    __asm   { POP   PSW     }               
//    __asm   { POP   DR0     }               
//    __asm   { POP   DR4     }               
//    __asm   { POP   DR8     }               
//    __asm   { POP   DR12    }               
//    __asm   { POP   DR16    }               
//    __asm   { POP   DR20    }               
//    __asm   { POP   DR24    }               
//    __asm   { POP   DR28    }               
//    __asm   { POP   DR56    }               
//    __asm   { SETB  EA      }
//    __asm   { RETI    } 

//3ʹPendSvIsrжлһ
//ָDR0ڴλáSP浽ƿʱʵʲMOV   DR0,DR0ҲDR0ֵ     

    OSTCBCur      = (OS_TCB *)0;   
    PendSv_GenerateSWInterrupt();
    EA = 1;
    while(1);
}


/*-----------------------------------------------------------*
PendSv жл
*-----------------------------------------------------------*/
void OS_CPU_PendSVHandler( void )
{
    //ڱţжתڱ,hugelarge洢ģʽһֲһ⡣
    __asm   {OS_CPU_PendSVHandler_00:  }
    //Ĵջ
    __asm   { PUSH  DR56    }               
    __asm   { PUSH  DR28    }               
    __asm   { PUSH  DR24    }               
    __asm   { PUSH  DR20    }               
    __asm   { PUSH  DR16    }               
    __asm   { PUSH  DR12    }               
    __asm   { PUSH  DR8     }               
    __asm   { PUSH  DR4     }               
    __asm   { PUSH  DR0     }               
    __asm   { PUSH  PSW     }
    
    
    //SP浽ƿ                        
    __asm   { MOV   DR0,DR60 }           
    __asm   { MOV   DR4,OSTCBCur }   
    __asm   { MOV   @WR6+0x2,WR2 }
    
    
    //沢EA  ʵEA=0ҲжϷصʱEA=0ǳԱbug
//    __asm   { SETB  C                }
//    __asm   { JBC   EA,PendSvIsr_01  }
//    __asm   { CLR   C                }
//    __asm   { PendSvIsr_01:          }
//    __asm   { PUSH  PSW              }

    OSTaskSwHook();
    OSPrioCur = OSPrioHighRdy;
    OSTCBCur  = OSTCBHighRdy;

    //ָEA
//    __asm{  POP   PSW       }
//    __asm{   MOV   EA,C     }

    //ȡSP
// ;OSTCBCur  = OSTCBHighRdy; Ļ
//        MOV      DR4,OSTCBHighRdy
//        MOV      OSTCBCur,DR4
//˵DR4ֵѾOSTCBCur
//    __asm   { MOV   DR4,OSTCBCur    }   
    __asm   { MOV   WR2,@WR6+0x2    }   
    __asm   { MOV   DR60,DR0        } 
    
    //Ĵջ
    __asm   { POP   PSW     }               
    __asm   { POP   DR0     }               
    __asm   { POP   DR4     }               
    __asm   { POP   DR8     }               
    __asm   { POP   DR12    }               
    __asm   { POP   DR16    }               
    __asm   { POP   DR20    }               
    __asm   { POP   DR24    }               
    __asm   { POP   DR28    }               
    __asm   { POP   DR56    }               

    //жϷ
    __asm   { RETI }           
}


/*-----------------------------------------------------------*
ʱӵδж
*-----------------------------------------------------------*/
void Timer0_ISR_Handler (void) interrupt TMR0_VECTOR
{
    OSIntNesting++;     //ϵͳǰܿжϣȻһֱ++

    OSTimeTick();       //ucosʱӷ

    OSIntExit();        //˳ж
}
        

/*-----------------------------------------------------------*
PendSv 
*-----------------------------------------------------------*/

__asm   { CSEG    AT  PendSv_EntryAddress  }
__asm   { JMP     OS_CPU_PendSVHandler_00  }


